const PCCONFIGDBG = false;
const PROCESSDBG = false;
class PcConfig
{
   static dbg(doit) // careful, variadic via arguments global
    {
        if (doit)
        {

          var stack = new Error().stack;
          //  update is on this line
          var fields_of_interest = stack.split('\n')[2].trim().split(/\s+/);
          var caller = "";
          let filename = "";
          let fileline = "";

          let t;
          if (fields_of_interest.length > 2) {
            t = fields_of_interest.slice(-1)[0].split('/').slice(-1)[0].split(':');
            caller = fields_of_interest[1].split('.')[1];
          } else if(fields_of_interest.length >1) {
            t = fields_of_interest.slice(-1)[0].split('/').slice(-1)[0].split(':');
            //console.log("fields size 1", t);
          }
          filename = t[0];
          fileline = t.slice(-2)[0];
          //console.log("fn:", filename, "fl:", fileline, "caller", caller, "fields_of_interest", fields_of_interest);
          //console.log(stack);

            var final_log = "";
            for (var i = 1; i < arguments.length; i++) {
                final_log += " " + arguments[i];
            }
            console.log(filename + ":" + fileline + ":" + caller +":" + final_log);
        }
    }

  static useElectron()
  {
    return (window.require != false);
  }
  
  static initialize(fOnInitialize, xml, host, lang)
  {

    PcConfig.fOnInitialize = fOnInitialize;
    PcConfig.renderSize = 1;
    PcConfig.device = "";
    PcConfig.XMLUrl = xml!="" ? xml : "http://localhost/xml/config.xml";
    PcConfig.XMLData = null;
    PcConfig.XMLParser = new DOMParser();
    PcConfig.XML = null;
    PcConfig.JSON = null;
    PcConfig.host = host!="" ? host : "http://localhost/";
    PcConfig.sounds = null;
    PcConfig.memory = {};
    PcConfig.currentLanguage = lang;
    PcConfig.initialized = false;
    PcConfig.connected = true;
    PcConfig.onConnectionChange = null;

    PcConfig.framingAlert = [];

    if (this.useElectron()) {
      PcConfig.electron = require('electron').ipcRenderer;
    }
  
    PcConfig.PHPLocalGetStatus("initialize", false, ()=>{
        PcConfig.getXMLData();
        PcConfig.startServices();
    });

  }

  static sayAlive()
  {
    if (!PcConfig.useElectron()) return;

    let d = new Date();
    PcConfig.electron.send('alive', d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds());
  }

  static saySomething(s)
  {
    if (!PcConfig.useElectron()) return;

    const { ipcRenderer } = require('electron');
    let d = new Date();
    ipcRenderer.send(s, d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds());
  }

  static getXMLData()
    {
        PcConfig.dbg(PCCONFIGDBG, "getXMLData");
    $.ajax({
      url: PcConfig.XMLUrl + "?x=" + Math.random(),
      type: "GET",
      timeout:10000,
      dataType: "text",
      success: (data)=>{
        PcConfig.onGetXMLData(data);
      },
        error: (xhr, status, err)=>{
            PcConfig.dbg(PCCONFIGDBG, "ERROR, cannot download xml! please give some time for daemons to install the config from server. I will now restart");
            PcConfig.restartAll();
      }
    });
  }

  static onGetXMLData(data)
  {
    PcConfig.XMLData = data;
    PcConfig.XML = PcConfig.XMLParser.parseFromString(PcConfig.XMLData,"text/xml");
    PcConfig.JSON = PcConfig.xmlToJson(PcConfig.XML).root;

    //console.log(PcConfig.JSON);
    //console.log(this.scenario);
    //console.log(this.screen);
    //console.log(this.instantWin);

    PcConfig.initializeSounds();

    PcConfig.initializeTemplates(()=>{
      PcConfig.initializeFont(()=>{
        PcConfig.initialized = true;
        PcConfig.fOnInitialize();
      });
    });
  }

  static initializeSounds()
  {
    var sounds = {
      buttonStart : new PcAudio(this.getValue("file", "general.audio.buttonStart"), this.getValue("sndVolume", "general.audio.buttonStart")),
      buttonPrevious : new PcAudio(this.getValue("file", "general.audio.buttonPrevious"), this.getValue("sndVolume", "general.audio.buttonPrevious")),
      buttonNext : new PcAudio(this.getValue("file", "general.audio.buttonNext"), this.getValue("sndVolume", "general.audio.buttonNext")),
      buttonValidate : new PcAudio(this.getValue("file", "general.audio.buttonValidate"), this.getValue("sndVolume", "general.audio.buttonValidate")),
      keyboard : new PcAudio(this.getValue("file", "general.audio.keyboard"), this.getValue("sndVolume", "general.audio.keyboard")),
      counter1 : new PcAudio(this.getValue("file", "general.audio.counter1"), this.getValue("sndVolume", "general.audio.counter1")),
      counter2 : new PcAudio(this.getValue("file", "general.audio.counter2"), this.getValue("sndVolume", "general.audio.counter2")),
      counter3 : new PcAudio(this.getValue("file", "general.audio.counter3"), this.getValue("sndVolume", "general.audio.counter3")),
      flash : new PcAudio(this.getValue("file", "general.audio.flash"), this.getValue("sndVolume", "general.audio.flash")),
      flashLoop : new PcAudio(this.getValue("file", "general.audio.flashLoop"), this.getValue("sndVolume", "general.audio.flashLoop")),
      win : new PcAudio(this.getValue("file", "photoWin.general.sound"), this.getValue("sndVolume", "photoWin.general.sound")),
    }

    PcConfig.sounds = sounds;
  }

  static initializeTemplates(fOnLoad = null)
  {
    PcTemplates.initialize();

    let urlsToLoad = [];
    let k=0;

    let testLoading = (url)=>{

        for (let i=0; i<urlsToLoad.length; i++)
        {
          if (urlsToLoad[i].url==url) urlsToLoad[i].loaded = true;
        }

        for (let i=0; i<urlsToLoad.length; i++)
        {
          if (urlsToLoad[i].loaded==false) return;
        }

        if (fOnLoad) fOnLoad();
    }

    //load photo skins
    for (let i=0; i<this.getValue("number", "photoFormats.general.formats.count"); i++)
    {
      for (let j=0; j<this.getValue("number", "photoTemplateAndFilter.skins.skins"+i+".count"); j++)
      {
        let urlbg = this.getValue("file", "photoTemplateAndFilter.skins.skins"+i+".background"+j);
        let urlfg = this.getValue("file", "photoTemplateAndFilter.skins.skins"+i+".foreground"+j);

        if (urlbg!="")
        {
          urlsToLoad[k] = {url:urlbg, loaded:false};
          k++;
        }

        if (urlfg!="")
        {
          urlsToLoad[k] = {url:urlfg, loaded:false};
          k++;
        }
      }
    }

    //load instant win skins
    for (let i=0; i<this.getValue("number", "photoFormats.general.formats.count"); i++)
    {
      for (let j=0; j<this.getValue("number", "photoWin.skins.skins"+i+".count"); j++)
      {
        let urlbg = this.getValue("file", "photoWin.skins.skins"+i+".background"+j);
        let urlfg = this.getValue("file", "photoWin.skins.skins"+i+".foreground"+j);

        if (urlbg!="")
        {
          urlsToLoad[k] = {url:urlbg, loaded:false};
          k++;
        }

        if (urlfg!="")
        {
          urlsToLoad[k] = {url:urlfg, loaded:false};
          k++;
        }
      }
    }

    for (let i=0; i<urlsToLoad.length; i++)
    {
      PcTemplates.loadResource(urlsToLoad[i].url, testLoading);
    }

    if (urlsToLoad.length==0)
    {
      if (fOnLoad) fOnLoad();
    }
  }

  static initializeFont(fOnLoad = null)
  {
    if (PcConfig.scenario.fontFamily=="custom")
    {
      console.log("custom font", PcConfig.scenario.fontFile);

      let fontUrl = PcConfig.scenario.fontFile;
      let customFont = new FontFace("custom", "url("+fontUrl+")");
      customFont.load().then((loadedFace)=>{
        document.fonts.add(loadedFace);
      });

      if (fOnLoad) fOnLoad();
    }
    else {
      if (fOnLoad) fOnLoad();
    }
  }

  static getValue(type, tree)
  {
    let i=0;
    let node = PcConfig.JSON;
    let atree = tree.split(".");

    try
    {
      while (i<atree.length)
      {
        node = node[atree[i]];
        i++;
      }

      if (type=="string")
      {
        if (node["lang0"])
        {
          return node["lang"+PcConfig.currentLanguage]["_value"];
        }
        else {
          return node["_value"];
        }
      }
      else if (type=="file")
      {
        if (node["lang0"])
        {
          if (node["lang"+PcConfig.currentLanguage]["_value"]==undefined)
          {
            return ""
          } else {
            return PcConfig.host + node["lang"+PcConfig.currentLanguage]["_value"];
          }
        }
        else {
          if (node["_value"]==undefined)
          {
            return ""
          } else {
            return PcConfig.host + node["_value"];
          }
        }
      }
      else if (type=="color")
      {
        return "#" + node["_value"];
      }
      else if (type=="number")
      {
        let n = Number(node["_value"]);
        if (!isNaN(n)) {return n;} else {return "";};
      }
      else if (type=="boolean")
      {
        return Number(node["_value"])==1 ? true : false;
      }
      else if (type=="sndVolume")
      {
        return Number(node["_attributes"]["volume"]);
      }
    } catch (e) //node doesn't exist
    {
      if (type=="number") { return 0;}
      else if (type=="color") { return "#000000";}
      else if (type=="boolean") { return false;}
      else { return "";}
    }

  }

  static get global()
  {
    return {
      id:this.getValue("string", "id"),
      name:this.getValue("string", "general.configuration.name"),
      recorderURL : (PcConfig.useElectron()? __dirname : "") + "/recorder/Photocabine.exe",
      recordedFolder : "c:/www/scripts/shoot/input/",
      recordedFolderForSave : "scripts/shoot/input/",
      recordedFolderForDelete : "\"c:\\www\\scripts\\shoot\\input\\*\"",
    }
  }

  static get scenario()
  {
    return {
      mode:this.getValue("string", "general.configuration.mode"),
      backgroundColor:this.getValue("color", "general.display.backgroundColor"),
      background:this.getValue("file", "general.display.background"),
      fontFamily:this.getValue("string", "general.display.font"),
      fontFile:this.getValue("file", "general.display.fontFile"),
      fontSizeGiant: (85*PcConfig.renderSize) * this.getValue("number", "general.display.fontSize")/100 + "px",
      fontSizeVeryVeryBig: (78*PcConfig.renderSize) * this.getValue("number", "general.display.fontSize")/100 + "px",
      fontSizeVeryBig: (70*PcConfig.renderSize) * this.getValue("number", "general.display.fontSize")/100 + "px",
      fontSizeBig: (55*PcConfig.renderSize) * this.getValue("number", "general.display.fontSize")/100 + "px",
      fontSize: (40*PcConfig.renderSize) * this.getValue("number", "general.display.fontSize")/100 + "px",
      fontSizeMedium: (30*PcConfig.renderSize) * this.getValue("number", "general.display.fontSize")/100 + "px",
      fontSizeSmall: (20*PcConfig.renderSize) * this.getValue("number", "general.display.fontSize")/100 + "px",
      fontSizeKeyboard: (30*PcConfig.renderSize) + "px",
      fontSizeKeyboardSmall: (26*PcConfig.renderSize) + "px",
      fontColor:this.getValue("color", "general.display.fontColor"),
      counterFontColor:this.getValue("color", "general.display.counterFontColor"),
      standardButtonBorderColor: this.getValue("color", "general.display.buttonBorderColor"),
      standardButtonBackgroundColor: this.getValue("color", "general.display.buttonBackgroundColor"),
      standardButtonTextColor: this.getValue("color", "general.display.buttonFontColor"),
      actionButtonBorderColor: this.getValue("color", "general.display.actionButtonBorderColor"),
      actionButtonBackgroundColor: this.getValue("color", "general.display.actionButtonBackgroundColor"),
      actionButtonTextColor: this.getValue("color", "general.display.actionButtonFontColor"),
      startButtonBorderColor: this.getValue("color", "general.display.startButtonBorderColor"),
      startButtonBackgroundColor: this.getValue("color", "general.display.startButtonBackgroundColor"),
      startButtonTextColor: this.getValue("color", "general.display.startButtonFontColor"),
      langButtonBorderColor: this.getValue("color", "general.display.langButtonBorderColor"),
      langButtonBackgroundColor: this.getValue("color", "general.display.langButtonBackgroundColor"),
      langButtonTextColor: this.getValue("color", "general.display.langButtonFontColor"),
      keyboardTextColor:this.getValue("color", "general.display.keyboardFontColor"),
      keyboardBackgroundColor:this.getValue("color", "general.display.keyboardBackgroundColor"),
      buttonsStyle: this.getValue("string", "general.display.buttonsStyle"),
      titlesStyle: this.getValue("string", "general.display.titlesStyle"),
      buttonsBorderWidth: (6*PcConfig.renderSize),
      screensAnimationStyle:"screenFadeIn 0.15s ease-out 0s 1 normal forwards",
      elementsAnimationStyle:"elementMoveDownAndFadeIn 0.5s ease-out 0s 1 normal forwards",
      sleepTimer:this.getValue("number", "general.configuration.sleepTime")!="" ? Math.max(20, this.getValue("number", "general.configuration.sleepTime"))*1000 : 60*1000,
      cameraOrientation:this.getValue("string", "general.configuration.cameraOrientation"),
      detectConnection:this.getValue("boolean", "general.configuration.detectConnection"),
      useWebcam:this.getValue("boolean", "general.configuration.useWebcam"),
      languages:(()=>{
        var res=[];
        res[0] = {
          index:0,
          label:this.getValue("string", "general.configuration.languagesDefaultLabel"),
          symbol:this.getValue("string", "general.configuration.languagesDefaultSymbol"),
        }
        for (let i=0; i<this.getValue("number", "general.configuration.languages.count"); i++)
        {
          res[i+1] = {
            index:i+1,
            label:this.getValue("string", "general.configuration.languages.label"+i),
            symbol:this.getValue("string", "general.configuration.languages.symbol"+i),
          };
        }
        return res;
      })()
    };
  }

  static get screen()
  {
    let modeWord;

    switch (this.scenario.mode)
    {
      case "photobooth" : case "photokiosk" : case "cyclomaton" : modeWord = "photo"; break;
      case "videobooth" : case "videokiosk" : modeWord = "video"; break;
    }

    return {
      intro:{
          title:this.getValue("string", modeWord+"Intro.general.text"),
          titleColor:this.getValue("boolean", modeWord+"Intro.advanced.textColorOverride") ? this.getValue("color", modeWord+"Intro.advanced.textColor") : this.getValue("color", "general.display.fontColor"),
          titlePosition:this.getValue("string", modeWord+"Intro.general.textPosition"),
          background:this.getValue("file", modeWord+"Intro.general.background"),
      },

      menu:{
          title:this.getValue("string", "videoMenu.general.title"),
          background:this.getValue("file", "videoMenu.general.background"),
          themes:(()=>{
            var res=[];
            for (let i=0; i<this.getValue("number", "videoMenu.themes.themes.count"); i++)
            {
              res[i] = {
                index:i,
                label:this.getValue("string", "videoMenu.themes.themes.label"+i),
                textStart:this.getValue("string", "videoMenu.themes.themes.textStart"+i),
                background:this.getValue("file", "videoMenu.themes.themes.background"+i),
                textCapture:this.getValue("string", "videoMenu.themes.themes.textCapture"+i),
                introPicture:this.getValue("file", "videoMenu.themes.themes.introPicture"+i),
                maskPreviewPicture:this.getValue("file", "videoMenu.themes.themes.maskPreviewPicture"+i),
                maskPicture:this.getValue("file", "videoMenu.themes.themes.maskPicture"+i),
              };
            }
            if (res.length==0)
            {
              res[0] = {
                index:0,
                label:"Thème",
                textStart:"Texte du thème",
                background:"",
                textCapture:"Texte pendant la capture",
                introPicture:"",
                maskPreviewPicture:"",
                maskPicture:"",
              };
            }
            return res;
          })(),
          previousButton:{
            title: this.getValue("string", "videoMenu.general.buttonPrev"),
            backgroundColor:this.getValue("boolean", "videoMenu.advanced.buttonsOverride") ? this.getValue("color", "videoMenu.advanced.buttonPrevBackgroundColor") : this.getValue("color", "general.display.buttonBackgroundColor"),
            borderColor:this.getValue("boolean", "videoMenu.advanced.buttonsOverride") ? this.getValue("color", "videoMenu.advanced.buttonPrevBorderColor") : this.getValue("color", "general.display.buttonBorderColor"),
            fontColor:this.getValue("boolean", "videoMenu.advanced.buttonsOverride") ? this.getValue("color", "videoMenu.advanced.buttonPrevFontColor") : this.getValue("color", "general.display.buttonFontColor"),
          },
      },

      format:{
          title:this.getValue("string", "photoFormats.general.title"),
          background:this.getValue("file", "photoFormats.general.background"),
          formats:(()=>{
            var res=[];
            for (let i=0; i<this.getValue("number", "photoFormats.general.formats.count"); i++)
            {
              res[i] = {
                index:i,
                label:this.getValue("string", "photoFormats.general.formats.label"+i),
                paper:this.getValue("string", "photoFormats.general.formats.paper"+i),
                poses:this.getValue("string", "photoFormats.general.formats.poses"+i),
                layout:this.getValue("string", "photoFormats.general.formats.layout"+i),
                framing:this.getValue("string", "photoFormats.general.formats.framing"+i),
                animation:this.getValue("string", "photoFormats.general.formats.animation"+i),
                printing:this.getValue("boolean", "photoFormats.general.formats.printing"+i),
                autocrop:this.getValue("boolean", "photoFormats.general.formats.autocrop"+i),
                autocropSize:this.getValue("number", "photoFormats.general.formats.autocropSize"+i) != "" ? this.getValue("number", "photoFormats.general.formats.autocropSize"+i) : 35,
                autocropPosition:this.getValue("number", "photoFormats.general.formats.autocropPosition"+i) != "" ? this.getValue("number", "photoFormats.general.formats.autocropPosition"+i) : 0,
                autocropSoft:this.getValue("boolean", "photoFormats.general.formats.autocropSoft"+i),
                foreground:this.getValue("file", "photoFormats.general.formats.foreground"+i),
                defaultSkin:
                {
                  color:this.getValue("color", "photoTemplateAndFilter.skins.skins"+i+".backgroundColor0"),
                  background:this.getValue("file", "photoTemplateAndFilter.skins.skins"+i+".background0"),
                  foreground:this.getValue("file", "photoTemplateAndFilter.skins.skins"+i+".foreground0"),
                },
              };
            }
            return res;
          })(),
          idActive:this.getValue("boolean", "photoFormats.id.active"),
          idWidth:this.getValue("number", "photoFormats.id.width"),
          idHeight:this.getValue("number", "photoFormats.id.height"),
          idAutocropSize:this.getValue("number", "photoFormats.id.autocropSize"),
          idAutocropPosition:this.getValue("number", "photoFormats.id.autocropPosition"),
          idRecognitionThreshold:this.getValue("number", "photoFormats.advanced.recognitionThreshold"),
          idResizedWidth:this.getValue("number", "photoFormats.advanced.resizedWidth"),
          idModeSlow:this.getValue("number", "photoFormats.advanced.modeSlow"),
          idPreDownscale:this.getValue("number", "photoFormats.advanced.preDownscale"),
          idShowLandmarks:this.getValue("number", "photoFormats.advanced.showLandmarks"),
          wideCapture:this.getValue("boolean", "photoFormats.advanced.wideCapture"),
          filter:{title:"", filterName:"none", settings:""},
          previousButton:{
            title: this.getValue("string", "photoFormats.general.buttonPrev"),
            backgroundColor:this.getValue("boolean", "photoFormats.advanced.buttonsOverride") ? this.getValue("color", "photoFormats.advanced.buttonPrevBackgroundColor") : this.getValue("color", "general.display.buttonBackgroundColor"),
            borderColor:this.getValue("boolean", "photoFormats.advanced.buttonsOverride") ? this.getValue("color", "photoFormats.advanced.buttonPrevBorderColor") : this.getValue("color", "general.display.buttonBorderColor"),
            fontColor:this.getValue("boolean", "photoFormats.advanced.buttonsOverride") ? this.getValue("color", "photoFormats.advanced.buttonPrevFontColor") : this.getValue("color", "general.display.buttonFontColor"),
          },
          nextButton:{
            title:this.getValue("string", "photoFormats.general.buttonNext"),
            backgroundColor:this.getValue("boolean", "photoFormats.advanced.buttonsOverride") ? this.getValue("color", "photoFormats.advanced.buttonNextBackgroundColor") : this.getValue("color", "general.display.actionButtonBackgroundColor"),
            borderColor:this.getValue("boolean", "photoFormats.advanced.buttonsOverride") ? this.getValue("color", "photoFormats.advanced.buttonNextBorderColor") : this.getValue("color", "general.display.actionButtonBorderColor"),
            fontColor:this.getValue("boolean", "photoFormats.advanced.buttonsOverride") ? this.getValue("color", "photoFormats.advanced.buttonNextFontColor") : this.getValue("color", "general.display.actionButtonFontColor"),
          }
      },

      start:{
          title:this.getValue("string", "photoStart.general.title"),
          textNoDeviceDetected:this.getValue("string", "photoStart.general.textNoDeviceDetected"),
          background:this.getValue("file", "photoStart.general.background"),
          previousButton:{
            title: this.getValue("string", modeWord+"Start.general.buttonPrev"),
            backgroundColor:this.getValue("boolean", modeWord+"Start.advanced.buttonsOverride") ? this.getValue("color", modeWord+"Start.advanced.buttonPrevBackgroundColor") : this.getValue("color", "general.display.buttonBackgroundColor"),
            borderColor:this.getValue("boolean", modeWord+"Start.advanced.buttonsOverride") ? this.getValue("color", modeWord+"Start.advanced.buttonPrevBorderColor") : this.getValue("color", "general.display.buttonBorderColor"),
            fontColor:this.getValue("boolean", modeWord+"Start.advanced.buttonsOverride") ? this.getValue("color", modeWord+"Start.advanced.buttonPrevFontColor") : this.getValue("color", "general.display.buttonFontColor"),
          },
          startButton:{
            title:this.getValue("string", modeWord+"Start.general.buttonStart"),
            backgroundColor: this.getValue("color", "general.display.startButtonBackgroundColor"),
            borderColor: this.getValue("color", "general.display.startButtonBorderColor"),
            fontColor: this.getValue("color", "general.display.startButtonFontColor"),
          }
      },

      capture:{
          background:this.getValue("file", modeWord+"Capture.general.background"),
          framingOval:this.getValue("boolean", modeWord+"Capture.general.framingOval"),
          text:(()=>{
            var res=[];
            for (let i=0; i<=5; i++)
            {
              res[i] = this.getValue("string", "photoCapture.counter.text"+i);
            }
            return res;
          })(),
          textBoomerang:(()=>{
            var res=[];
            for (let i=0; i<=5; i++)
            {
              res[i] = this.getValue("string", "photoCapture.counterBoomerang.text"+i);
            }
            return res;
          })(),
          textCount:this.getValue("string", "photoCapture.counter.textCount"),
          textCountBoomerang:this.getValue("string", "photoCapture.counterBoomerang.textCount"),
          recordingTime:Math.max(this.getValue("number", "videoCapture.general.recordingTime"), 5),
          introTextVideo:this.getValue("string", "videoCapture.general.introText"),
          textVideo:this.getValue("string", "videoCapture.general.text"),
          endButton:{
            title:this.getValue("string", "videoCapture.general.buttonEnd"),
          }
      },

      loading:{
          title:this.getValue("string", modeWord+"Loading.general.title"),
          background:this.getValue("file", modeWord+"Loading.general.background"),
      },

      templateAndFilter:{
        title:this.getValue("string", "photoTemplateAndFilter.general.title"),
        background:this.getValue("file", "photoTemplateAndFilter.general.background"),
        framingBackground:this.getValue("file", "photoTemplateAndFilter.framing.background"),
        framingText1:this.getValue("string", "photoTemplateAndFilter.framing.text1"),
        framingText2:this.getValue("string", "photoTemplateAndFilter.framing.text2"),
        framingTextFace:this.getValue("string", "photoTemplateAndFilter.framing.textFace"),
        framingTextSize:this.getValue("string", "photoTemplateAndFilter.framing.textSize"),
        framingTextUp:this.getValue("string", "photoTemplateAndFilter.framing.textUp"),
        framingTextDown:this.getValue("string", "photoTemplateAndFilter.framing.textDown"),
        framingTextLeft:this.getValue("string", "photoTemplateAndFilter.framing.textLeft"),
        framingTextRight:this.getValue("string", "photoTemplateAndFilter.framing.textRight"),
        framingButtonLabel:this.getValue("string", "photoTemplateAndFilter.framing.buttonPrev"),
        skins:(()=>{
          var res=[];
          var i=0;
          for (let i=0; i<this.getValue("number", "photoFormats.general.formats.count"); i++)
          {
            let subres=[];
            for (let j=0; j<this.getValue("number", "photoTemplateAndFilter.skins.skins"+i+".count"); j++)
            {
              subres[j] = {
                color:this.getValue("color", "photoTemplateAndFilter.skins.skins"+i+".backgroundColor"+j),
                background:this.getValue("file", "photoTemplateAndFilter.skins.skins"+i+".background"+j),
                foreground:this.getValue("file", "photoTemplateAndFilter.skins.skins"+i+".foreground"+j),
              }
            }

            if (subres.length==0) subres[0] = { color:"#FFFFFF", background:"", foreground:""}

            res[i] = subres;
            //i++;
          }
          if (res.length==0)
          {
            let subres=[];
            subres[0] = { color:"#FFFFFF", background:"", foreground:""}
            res[0] = subres;
          }
          return res;
        })(),
        filters:(()=>{
          var res=[];
          for (let i=0; i<this.getValue("number", "photoTemplateAndFilter.filters.filters.count"); i++)
          {
            res[i] = {
              title:this.getValue("string", "photoTemplateAndFilter.filters.filters.label"+i),
              filterName:this.getValue("string", "photoTemplateAndFilter.filters.filters.filter"+i),
              settings:this.getValue("string", "photoTemplateAndFilter.filters.filters.settings"+i),
              id:this.getValue("string", "photoTemplateAndFilter.filters.filters.filter"+i) + ":" + this.getValue("string", "photoTemplateAndFilter.filters.filters.settings"+i),
            };
          }
          if (res.length==0)
          {
            res[0] = {
              title:"nofilter",
              filterName:"none",
              settings:"",
              id:"none",
            };
          }
          return res;
        })(),
        defaultFilterIndex : this.getValue("number", "photoTemplateAndFilter.filters.defaultFilterIndex")-1,
        previousButton:{
          title: this.getValue("string", "photoTemplateAndFilter.general.buttonPrev"),
          backgroundColor:this.getValue("boolean", "photoTemplateAndFilter.advanced.buttonsOverride") ? this.getValue("color", "photoTemplateAndFilter.advanced.buttonPrevBackgroundColor") : this.getValue("color", "general.display.buttonBackgroundColor"),
          borderColor:this.getValue("boolean", "photoTemplateAndFilter.advanced.buttonsOverride") ? this.getValue("color", "photoTemplateAndFilter.advanced.buttonPrevBorderColor") : this.getValue("color", "general.display.buttonBorderColor"),
          fontColor:this.getValue("boolean", "photoTemplateAndFilter.advanced.buttonsOverride") ? this.getValue("color", "photoTemplateAndFilter.advanced.buttonPrevFontColor") : this.getValue("color", "general.display.buttonFontColor"),
        },
        nextButton:{
          title:this.getValue("string", "photoTemplateAndFilter.general.buttonNext"),
          backgroundColor:this.getValue("boolean", "photoTemplateAndFilter.advanced.buttonsOverride") ? this.getValue("color", "photoTemplateAndFilter.advanced.buttonNextBackgroundColor") : this.getValue("color", "general.display.actionButtonBackgroundColor"),
          borderColor:this.getValue("boolean", "photoTemplateAndFilter.advanced.buttonsOverride") ? this.getValue("color", "photoTemplateAndFilter.advanced.buttonNextBorderColor") : this.getValue("color", "general.display.actionButtonBorderColor"),
          fontColor:this.getValue("boolean", "photoTemplateAndFilter.advanced.buttonsOverride") ? this.getValue("color", "photoTemplateAndFilter.advanced.buttonNextFontColor") : this.getValue("color", "general.display.actionButtonFontColor"),
        }
      },

      preview:{
        title:this.getValue("string", "videoPreview.general.title"),
        background:this.getValue("file", "videoPreview.general.background"),
        previousButton:{
          title: this.getValue("string", "videoPreview.general.buttonPrev"),
          backgroundColor:this.getValue("boolean", "videoPreview.advanced.buttonsOverride") ? this.getValue("color", "videoPreview.advanced.buttonPrevBackgroundColor") : this.getValue("color", "general.display.buttonBackgroundColor"),
          borderColor:this.getValue("boolean", "videoPreview.advanced.buttonsOverride") ? this.getValue("color", "videoPreview.advanced.buttonPrevBorderColor") : this.getValue("color", "general.display.buttonBorderColor"),
          fontColor:this.getValue("boolean", "videoPreview.advanced.buttonsOverride") ? this.getValue("color", "videoPreview.advanced.buttonPrevFontColor") : this.getValue("color", "general.display.buttonFontColor"),
        },
        nextButton:{
          title:this.getValue("string", "videoPreview.general.buttonNext"),
          backgroundColor:this.getValue("boolean", "videoPreview.advanced.buttonsOverride") ? this.getValue("color", "videoPreview.advanced.buttonNextBackgroundColor") : this.getValue("color", "general.display.actionButtonBackgroundColor"),
          borderColor:this.getValue("boolean", "videoPreview.advanced.buttonsOverride") ? this.getValue("color", "videoPreview.advanced.buttonNextBorderColor") : this.getValue("color", "general.display.actionButtonBorderColor"),
          fontColor:this.getValue("boolean", "videoPreview.advanced.buttonsOverride") ? this.getValue("color", "videoPreview.advanced.buttonNextFontColor") : this.getValue("color", "general.display.actionButtonFontColor"),
        }
      },

      infos:{
          title:this.getValue("string", modeWord+"Infos.general.title"),
          background:this.getValue("file", modeWord+"Infos.general.background"),
          popButtonLabel:this.getValue("string", modeWord+"Infos.advanced.popButton"),

          questions:(()=>{
            var res=[];

            for (let i=0; i<this.getValue("number", modeWord+"Infos.questions.questions.count"); i++)
            {
                let kind = this.getValue("string", modeWord+"Infos.questions.questions.kind"+i);
                if (kind!="none")
                {
                  res[i] = {
                    index:i,
                    kind:kind,
                    required:this.getValue("boolean", modeWord+"Infos.questions.questions.required"+i),
                    label:this.getValue("string", modeWord+"Infos.questions.questions.label"+i),
                    mention:this.getValue("string", modeWord+"Infos.questions.questions.mention"+i),
                    choices:this.getValue("string", modeWord+"Infos.questions.questions.choices"+i),
                    error:this.getValue("string", modeWord+"Infos.questions.questions.errorMessage"+i),
                    prefill:this.getValue("number", modeWord+"Infos.questions.questions.prefillIndex"+i),
                    file:this.getValue("file", modeWord+"Infos.questions.questions.file"+i),
                    doc:this.getValue("file", modeWord+"Infos.questions.questions.doc"+i),
                    min:this.getValue("number", modeWord+"Infos.questions.questions.min"+i),
                    max:this.getValue("number", modeWord+"Infos.questions.questions.max"+i),
                    uppercase : this.getValue("boolean", modeWord+"Infos.questions.questions.uppercase"+i),
                  }

                  if (res[i].kind=="prints")
                  {
                    let min = res[i].min!="" ? res[i].min : 1;
                    let max = res[i].max!="" ? res[i].max : 3;
                    let choicesData = []
                    for(let j=0; j<=max-min; j++) choicesData[j] = j+min;
                    res[i].choices = choicesData.join("|");
                  }
                }
                else {
                  break;
                }
            }
            return res;
          })(),
          textListing : this.getValue("string", modeWord+"Infos.advanced.listingNotInList"),
          previousButton:{
            title: this.getValue("string", modeWord+"Infos.general.buttonPrev"),
            backgroundColor:this.getValue("boolean", modeWord+"Infos.advanced.buttonsOverride") ? this.getValue("color", modeWord+"Infos.advanced.buttonPrevBackgroundColor") : this.getValue("color", "general.display.buttonBackgroundColor"),
            borderColor:this.getValue("boolean", modeWord+"Infos.advanced.buttonsOverride") ? this.getValue("color", modeWord+"Infos.advanced.buttonPrevBorderColor") : this.getValue("color", "general.display.buttonBorderColor"),
            fontColor:this.getValue("boolean", modeWord+"Infos.advanced.buttonsOverride") ? this.getValue("color", modeWord+"Infos.advanced.buttonPrevFontColor") : this.getValue("color", "general.display.buttonFontColor"),
          },
          nextButton:{
            title:this.getValue("string", modeWord+"Infos.general.buttonNext"),
            titleValidate:this.getValue("string", modeWord+"Infos.general.buttonValidate"),
            backgroundColor:this.getValue("boolean", modeWord+"Infos.advanced.buttonsOverride") ? this.getValue("color", modeWord+"oInfos.advanced.buttonNextBackgroundColor") : this.getValue("color", "general.display.actionButtonBackgroundColor"),
            borderColor:this.getValue("boolean", modeWord+"Infos.advanced.buttonsOverride") ? this.getValue("color", modeWord+"Infos.advanced.buttonNextBorderColor") : this.getValue("color", "general.display.actionButtonBorderColor"),
            fontColor:this.getValue("boolean", modeWord+"Infos.advanced.buttonsOverride") ? this.getValue("color", modeWord+"Infos.advanced.buttonNextFontColor") : this.getValue("color", "general.display.actionButtonFontColor"),
          },
          okButton:{
            backgroundColor:this.getValue("boolean", modeWord+"Infos.general.buttonOkOverride") ? this.getValue("color", modeWord+"Infos.general.buttonOkBackgroundColor") : this.getValue("color", "general.display.actionButtonBackgroundColor"),
            borderColor:this.getValue("boolean", modeWord+"Infos.general.buttonOkOverride") ? this.getValue("color", modeWord+"Infos.general.buttonOkBorderColor") : this.getValue("color", "general.display.actionButtonBorderColor"),
            fontColor:this.getValue("boolean", modeWord+"Infos.general.buttonOkOverride") ? this.getValue("color", modeWord+"Infos.general.buttonOkFontColor") : this.getValue("color", "general.display.actionButtonFontColor"),
          },
      },

      end:{
        title:this.getValue("string", modeWord+"End.general.title"),
        background:this.getValue("file", modeWord+"End.general.background"),
        popButtonLabel:this.getValue("string", modeWord+"Infos.advanced.popButton"),
        nextButton:{
          title:this.getValue("string", modeWord+"End.general.buttonNext"),
          backgroundColor:this.getValue("boolean", modeWord+"End.advanced.buttonsOverride") ? this.getValue("color", modeWord+"End.advanced.buttonNextBackgroundColor") : this.getValue("color", "general.display.actionButtonBackgroundColor"),
          borderColor:this.getValue("boolean", modeWord+"End.advanced.buttonsOverride") ? this.getValue("color", modeWord+"End.advanced.buttonNextBorderColor") : this.getValue("color", "general.display.actionButtonBorderColor"),
          fontColor:this.getValue("boolean", modeWord+"End.advanced.buttonsOverride") ? this.getValue("color", modeWord+"End.advanced.buttonNextFontColor") : this.getValue("color", "general.display.actionButtonFontColor"),
        }
      }
    }
  }

  static get instantWin()
  {
    return {
      active:this.getValue("boolean", "photoWin.general.active"),
      title:this.getValue("string", "photoWin.general.title"),
      background:this.getValue("file", "photoWin.general.background"),
      lots:(()=>{
        var lots=[];
        for (let i=0; i<this.getValue("number", "photoWin.lots.lots.count"); i++)
        {
          let subres=[];
          for (let j=0; j<this.getValue("number", "photoFormats.general.formats.count"); j++)
          {
            subres[j] = [{
              color:this.getValue("color", "photoWin.skins.skins"+j+".backgroundColor"+i),
              background:this.getValue("file", "photoWin.skins.skins"+j+".background"+i),
              foreground:this.getValue("file", "photoWin.skins.skins"+j+".foreground"+i),
            }];
          }
          lots[i] = subres;
        }
        return lots;
      })(),
    };
  }

  static get keyboard()
  {
    let modeWord;

    switch (this.scenario.mode)
    {
      case "photobooth" : case "photokiosk" : case "cyclomaton" : modeWord = "photo"; break;
      case "videobooth" : case "videokiosk" : modeWord = "video"; break;
    }

    let domain1 = this.getValue("string", modeWord+"Infos.keyboards.emaildomain1");
    let domain2 = this.getValue("string", modeWord+"Infos.keyboards.emaildomain2");

    if (domain1=="") domain1 = "gmail.com";
    if (domain2=="") domain2 = "hotmail.com";

    return {
      domain1:domain1,
      domain2:domain2,
    }
  }

  static setMemory(name, value)
  {
    PcConfig.dbg(CRASHDBG, "name", name, "val", value);
    PcConfig.memory[name] = value;
  }

  static getMemory(name)
  {
    return PcConfig.memory[name]!=undefined ? PcConfig.memory[name] : "";
  }

  static myProcessExec(cmd, cb)
  {
      let process = require('electron').remote.require("child_process");
      PcConfig.dbg(PROCESSDBG, "executing command", cmd);
      var cp = process.exec(cmd, cb);
      return cp;
  }
  static resetMemory()
  {
    for (let e in PcConfig.memory)
    {
      PcConfig.memory[e] = null;
      delete PcConfig.memory[e];
    }
  }

  static restartAll()
  {

    let app = require('electron').remote.app;

    let cmd =  "\"" + PcConfig.global.recorderURL + "\" /StopRecording";
    PcConfig.myProcessExec(cmd);

    cmd =  "\"" + PcConfig.global.recorderURL + "\" /StopLiveView";
    PcConfig.myProcessExec(cmd);

    cmd =  'Taskkill /IM Photocabine.Process.exe /F /T';
    setTimeout(()=>PcConfig.myProcessExec(cmd), 1000);

    app.relaunch();
    setTimeout(()=>app.quit(), 2000);
  }

  static exitAll()
  {
    let process = require('electron').remote.require("child_process");
    let app = require('electron').remote.app;

    let cmd =  "\"" + PcConfig.global.recorderURL + "\" /StopRecording";
    PcConfig.myProcessExec(cmd);

    cmd =  "\"" + PcConfig.global.recorderURL + "\" /StopLiveView";
    PcConfig.myProcessExec(cmd);

    cmd =  'Taskkill /IM Photocabine.Process.exe /F /T';
    setTimeout(()=>PcConfig.myProcessExec(cmd), 1000);
    setTimeout(()=>app.quit(), 2000);
  }

  static startServices()
  {
      PcConfig.dbg(PCCONFIGDBG, "start services");
      PcConfig.PHPLocalGetStatus("startservices", true, null);
  }

   static _cleanNeedsReboot() 
    {
       PcConfig.dbg(PCCONFIGDBG, "entering _cleanNeedsReboot"); 
       $.ajax({ // warning, this is asynchronous. getting the feedback of _cleanNeedsReboot should be done by callbacks
           url: PcConfig.host + 'scripts/update_local_cabin_status.php?needs_reboot=0', 
           type: "GET",
           timeout:15000,
           success: (data)=>{
               PcConfig.dbg(PCCONFIGDBG, "success!", data);
           },
           error: (xhr, status, err)=>{
               //nothing to do
               PcConfig.dbg(PCCONFIGDBG, "error!", xhr, status, err);
           }
       });
       PcConfig.dbg(PCCONFIGDBG, "_cleanNeedsReboot: exit");
   }    
   
  static PHPLocalGetStatus(from, loop, onUpdate) // every 10 seconds.  returns an xml with <nb_photos>, <online>, <demo> and <nb_photos> tags. 
    {
      
    PcConfig.dbg(PCCONFIGDBG, "calling PHPLocalGetStatus from", from, "with onUpdate", onUpdate, "and occ", PcConfig.onConnectionChange);
    $.ajax({
      url: PcConfig.host + 'scripts/check_cabin_status.php', // this is the only caller to this script
      type: "GET",
      timeout:15000,
        success: (data)=>{
            // fixme: use returned xml data to update internet connection status
            PcConfig.dbg(PCCONFIGDBG, "xml data:", data);
            var json = PcConfig.xmlToJson(PcConfig.XMLParser.parseFromString(data,"text/xml"));
            PcConfig.dbg(PCCONFIGDBG, "json: ", JSON.stringify(json));
            PcConfig.dbg(PCCONFIGDBG, 'needs reboot value', json.xml.needs_reboot._value);; 
            // we have needs_reboot, config, device, nb_photos, online, printer_status, printer_photos_remaining, activate
            if (json.xml.needs_reboot._value != 0) {
                PcConfig._cleanNeedsReboot();
                if (!onUpdate) {
                    PcConfig.restartAll();
                }
            }
            if (onUpdate) { //conservative but kind of suboptimal
                onUpdate();
                return;
            }
            PcConfig.connected = json.xml.online._value != 0 ? true: false;
            PcConfig.dbg(PCCONFIGDBG, "connected:", PcConfig.connected);
            if (!PcConfig.scenario.detectConnection) {
                return; // stop here, don't call onConnectionChange
            }
            if (PcConfig.onConnectionChange) {
                PcConfig.dbg(PCCONFIGDBG, "declare connection change:", PcConfig.connected);
                PcConfig.onConnectionChange(PcConfig.connected);
            }

        },
        error: (xhr, status, err)=>{
            if (onUpdate){
                onUpdate();
                return;
            }
        },
        complete: (xhr, status)=> {
          if (loop) {
            setTimeout(()=>PcConfig.PHPLocalGetStatus("myself", true, null), 10000);
          }
        }
    });
  }

  //A timeout within a promise, so it can be thenable / waitable by Promise.all
  static promiseSleep (ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
  }
  
  static callSaveContent(raw_data, animation, onSuccess)
  {

    //form
    let formData = [];
    let form = "";

    for (let i=0; i<PcConfig.screen.infos.questions.length; i++)
    {
      if (PcConfig.screen.infos.questions[i].kind=="prints" && PcConfig.screen.format.formats[PcConfig.getMemory("currentFormatIndex")].printing==false)
      {
        formData[i] = 0;
      }
      else {
        formData[i] = PcConfig.getMemory("question"+i);
      }
    }

    if (PcConfig.getMemory("currentId")!="")
    {
      formData.push("listing:" + PcConfig.getMemory("currentId").join(","));
    }

    form = formData.join("|-|");

    //optins
    let optin = [-1, -1, -1];
    let j=0;
    for (let i=0; i<PcConfig.screen.infos.questions.length && j<3; i++)
    {
      let q = PcConfig.screen.infos.questions[i];
      let qc = q.choices.split("|")
      if (q.kind=="uniqChoice" && qc.length==2)
      {
        (formData[i] == qc[0]) ? optin[j] = 1 : optin[j] = 0;
        j++;
      }
    }

    //email reference
    let email = "";

    if (email=="")
    {
      for (let i=0; i<PcConfig.screen.infos.questions.length; i++)
      {
        let q = PcConfig.screen.infos.questions[i];
        //if (q.kind=="email" || q.kind=="listing") {email = formData[i]; break;}
        if (q.kind=="email") {email = formData[i]; break;}
      }
    }

    let paper, poses, layout, template, prints, extras, habillage;

    if (PcConfig.scenario.mode=="photokiosk" || PcConfig.scenario.mode=="photobooth" || PcConfig.scenario.mode=="cyclomaton")
    {
      paper = PcConfig.screen.format.formats[PcConfig.getMemory("currentFormatIndex")].paper;
      poses = PcConfig.screen.format.formats[PcConfig.getMemory("currentFormatIndex")].poses;
      layout = PcConfig.screen.format.formats[PcConfig.getMemory("currentFormatIndex")].layout;
      template = PcTemplates.getTemplate(paper, poses, layout);

      prints = PcConfig.getMemory("prints")!="" ? PcConfig.getMemory("prints") : 1;
      if (PcConfig.screen.format.formats[PcConfig.getMemory("currentFormatIndex")].printing==false) prints = 0;

      extras = template.size.width + "x" + template.size.height;
      habillage = PcConfig.getMemory("currentFormatIndex") + "|" + PcConfig.getMemory("currentSkinIndex");
    }
    else {
      prints = 0;
      extras = "1920x1080";
      habillage = "0|0";
    }

    let data = {
      email:email,
      notif:optin[0],
      notif2:optin[1],
      notif3:optin[2],
      extras:extras,
      habillage:habillage,
      form:form,
      print:prints,
      lang:PcConfig.currentLanguage,
      anim:animation ? "1" : "",
      config:PcConfig.JSON.id._value,
    }

    if (PcConfig.scenario.mode=="videokiosk" || PcConfig.scenario.mode=="videobooth")
    {
      data.video = (PcConfig.getMemory('recordedVideoFileName')!="") ? (PcConfig.global.recordedFolderForSave + PcConfig.getMemory('recordedVideoFileName')) : "";
      data.video_question = PcConfig.getMemory('currentTheme');
      data.video_demo = PcCameraControl.useDSLR() ? 0 : 1;
    }

    if (PcConfig.getMemory("winner")==1)
    {
      data.winner = PcConfig.getMemory("winnerIdLot");
      data.winner_gain = PcConfig.getMemory("winnerLot");
    }

    let params = Object.keys(data).map(function(key) { return key + '=' + data[key];}).join('&');

    console.log("call save content");

    $.ajax({
      url: PcConfig.host + 'scripts/save_content.php?' + params,
      type: "POST",
      data: raw_data ? {image:raw_data} : "",
      timeout:60000,
      success: (data)=>{
        var json = PcConfig.xmlToJson(PcConfig.XMLParser.parseFromString(data,"text/xml"));
        if (onSuccess) onSuccess(json.xml.id._value);
      },
      error: (xhr, status, err)=>{
      }
    });
  }

  static callSaveGif(raw_data, id_photo, onSuccess, isId=false)
  {
    let data = {
      id_photo:id_photo,
      isId:isId
    }

    let params = Object.keys(data).map(function(key) { return key + '=' + data[key];}).join('&');

    console.log("call save gif");

    $.ajax({
      url: PcConfig.host + 'scripts/save_gif.php?' + params,
      type: "POST",
      data:{image:raw_data},
      timeout:60000,
      success: (data)=>{
        if (onSuccess) onSuccess();
      },
      error: (xhr, status, err)=>{
      }
    });
  }

  // tools ////////////////////////////////////////////////////////////////////
  static xmlToJson(xml)
  {
  	var obj = {};

  	if (xml.nodeType == 1) //element
    {
  		if (xml.attributes.length > 0) {
  		obj["_attributes"] = {};
  			for (var j = 0; j < xml.attributes.length; j++) {
  				var attribute = xml.attributes.item(j);
  				obj["_attributes"][attribute.nodeName] = attribute.nodeValue;
  			}
  		}
  	} else if (xml.nodeType == 3 || xml.nodeType == 4) { // text or cdata
  		obj = xml.nodeValue;
  	}

  	if (xml.hasChildNodes()) {
  		for(var i = 0; i < xml.childNodes.length; i++) {
  			var item = xml.childNodes.item(i);
  			var nodeName = item.nodeName;

        if (nodeName=="#text" || nodeName=="#cdata-section")
        {
          obj["_value"] = item.nodeValue;
        }
        else {
          if (typeof(obj[nodeName]) == "undefined") {
    				obj[nodeName] = PcConfig.xmlToJson(item);
    			} else {
    				if (typeof(obj[nodeName].push) == "undefined") {
    					var old = obj[nodeName];
    					obj[nodeName] = [];
    					obj[nodeName].push(old);
    				}
    				obj[nodeName].push(PcConfig.xmlToJson(item));
    			}
        }
  		}
  	}
  	return obj;
  };

}
