class PcForm extends React.Component
{
  constructor(props)
  {
    PcConfig.dbg(CRASHDBG, "entering");
    super(props);

    this.initialized = false;

    this.keyboard = React.createRef();

    this.formContainer = React.createRef();
    this.formElements = React.createRef();

    this.email = React.createRef();

    this.questions = [];
    for (let i=0; i<PcConfig.screen.infos.questions.length; i++) this.questions[i] = React.createRef();

    this.positions = [];
    this.elements = [];
    this.showKeyboard = [];
    this.showKeyboardId = [];
    this.keyboardKind = [];
    this.keyboardUppercase = [];
    this.currentElement = 0;
    this.positionWithoutKeyboard = PcMode.screen.infos.formPositionWithoutKeyboard*PcConfig.renderSize;
    this.positionWithKeyboard = PcMode.screen.infos.formPositionWithKeyboard*PcConfig.renderSize;
    this.positionWithKeyboardId = PcMode.screen.infos.formPositionWithKeyboardId*PcConfig.renderSize;

    this.nextButtonLabel = PcConfig.screen.infos.nextButton.title;
    this.nextButtonValidateLabel = PcConfig.screen.infos.nextButton.titleValidate;

    this.state = {keyboardKind:"email"};
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  componentDidMount()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    if (this.props.active) {
      this.initialize();
    }
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  componentDidUpdate()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    if (this.props.active) { 
      this.initialize();
    }
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  initialize()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    if (this.initialized) {      
      PcConfig.dbg(CRASHDBG, "PcForm is already initialized");
      return;
    }
    PcConfig.dbg(CRASHDBG, "FYI, this.questions.length ", this.questions.length, "PcC.screen.infos.questions.length", PcConfig.screen.infos.questions.length);
    if (this.questions.length > 0) {
       /* 
       IF there are questions, initialize allowNextButton() to the required value of the 1st question.
       THEN getNextButton() will handle calls to allowNextButton() for the other questions 
       */
      this.props.allowNextButton(! PcConfig.screen.infos.questions[0].required); 
    }
    let showKeyboard, keyboardType, keyboardUppercase;
    var ind = 0;

    for (let i=0; i<this.questions.length; i++)
    {
      switch (PcConfig.screen.infos.questions[i].kind)
      {
        case "email" : showKeyboard=true; keyboardType="email"; break;
        case "listing" : showKeyboard=true; keyboardType="text"; break;
        case "uniqChoice" : showKeyboard=false; keyboardType=""; break;
        case "multipleChoice" : showKeyboard=false; keyboardType=""; break;
        case "number" : showKeyboard=true; keyboardType="number"; break;
        case "text" : showKeyboard=true; keyboardType="text"; break;
        case "prints" : showKeyboard=false; keyboardType=""; break;
      }

      if (PcConfig.screen.infos.questions[i].kind=="prints" && PcConfig.screen.format.formats[PcConfig.getMemory("currentFormatIndex")].printing==false)
      {
        //do nothing
      }
      else {
        this.elements[ind] = this.questions[i];
        this.showKeyboard[ind] = showKeyboard;
        this.showKeyboardId[ind] = (PcConfig.screen.infos.questions[i].kind=="listing");
        this.keyboardKind[ind] = keyboardType;
        this.keyboardUppercase[ind] = PcConfig.screen.infos.questions[i].uppercase;
        ind++;
      }
    }

    for (let i=0; i<this.elements.length; i++)
    {
      this.positions[i] = ReactDOM.findDOMNode(this.elements[i].current).offsetTop;
    }

    this.keyboard.current.hide();

    this.refreshElements();

    this.initialized = true;
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  refreshElements()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    if (this.showKeyboard[this.currentElement])
    {
      if (this.showKeyboardId[this.currentElement])
      {
        ReactDOM.findDOMNode(this.formElements.current).style.top = (this.positionWithKeyboardId - this.positions[this.currentElement]) + "px";
      }
      else {
        ReactDOM.findDOMNode(this.formElements.current).style.top = (this.positionWithKeyboard - this.positions[this.currentElement]) + "px";
      }

      for (let i=0; i<this.elements.length; i++)
      {
        ReactDOM.findDOMNode(this.elements[i].current).style.opacity = (i==this.currentElement) ? 1 : 0;
      }

      setTimeout( () => {
        ReactDOM.findDOMNode(this).focus();
        this.elements[this.currentElement].current.setFocus();
        this.elements[this.currentElement].current.onKeyPressed("");
      }, 500);

      this.setState({keyboardKind:this.keyboardKind[this.currentElement], keyboardUppercase:this.keyboardUppercase[this.currentElement]});
      this.keyboard.current.show();
    }
    else {
      ReactDOM.findDOMNode(this.formElements.current).style.top = (this.positionWithoutKeyboard - this.positions[this.currentElement]) + "px";

      for (let i=0; i<this.elements.length; i++)
      {
        ReactDOM.findDOMNode(this.elements[i].current).style.opacity = 1/(Math.pow((Math.abs(i-this.currentElement)*1.5), 2)+1);
      }

      this.keyboard.current.hide();
    }

    for (let i=0; i<this.elements.length; i++) this.elements[i].current.focused = false;
    this.elements[this.currentElement].current.focused = true;
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  emailInputSwitchMode(mode, index)
  {
    PcConfig.dbg(CRASHDBG, "entering");
    console.log("email input switch mode", mode);
    if (mode=="email")
    {
      this.showKeyboardId[index] = false;
      this.keyboardKind[index]="email";
    }
    else
    {
      this.showKeyboardId[index] = true;
      this.keyboardKind[index]="text";
    }

    this.refreshElements();
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  emailInputSkip()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    this.props.forceNext();
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  reset()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    this.currentElement = 0;

    for (let i=0; i<this.elements.length; i++)
    {
      this.elements[i].current.reset();
    }

    this.refreshElements();
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  goPrevious()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    this.currentElement--;

    //CREDIT AGRICOLE EXCEPTION
    if (PcConfig.global.name.indexOf("CREDIT AGRICOLE ID")!=-1)
    {
      if (this.currentElement==1)
      {
        let q = PcConfig.getMemory("question"+0);
        if (q.indexOf("nouveau badge")!=-1 || q.indexOf("new badge")!=-1)
        {
           PcConfig.setMemory("question1", "");
           this.goPrevious();
           //this.currentElement--;
        }
      }
      PcConfig.dbg(CRASHDBG, "exiting");
    }
    //

    this.refreshElements();
  }

  goNext()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    if (this.currentElement+1>=this.elements.length) {
      return true;
    }

    this.currentElement++;

    //CREDIT AGRICOLE EXCEPTION
    if (PcConfig.global.name.indexOf("CREDIT AGRICOLE ID")!=-1)
    {
      if (this.currentElement==1)
      {
        let q = PcConfig.getMemory("question"+0);
        if (q.indexOf("nouveau badge")!=-1 || q.indexOf("new badge")!=-1)
        {
           PcConfig.setMemory("question1", "");
           //this.currentElement++;
           this.goNext();
        }
      }
    }
    //

    this.refreshElements();
    PcConfig.dbg(CRASHDBG, "exiting");
    return false;
  }

  onClickFormElement(n) // happens when we click on the form input or the ok button
  {
    PcConfig.dbg(CRASHDBG, "entering");
    if (this.currentElement==n) { // happens when we click on the form or the ok button with config featuring formular like 63219590421fe
        PcConfig.dbg(CRASHDBG, "exiting early, nothing to do");
        return;
    }
    console.log("formelement " + n);

    if (n<this.currentElement)
    {
      this.props.clickPrevious();
    }else {
      this.props.clickNext(); // comes from PcScreenInfo, no args (could add a sub-from here too)
    }
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  onClickOkButton()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    this.props.clickNext(); // clicking on the ok button is equivalent to calling the clicknext function from PCSI
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  getNextButton()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    let ret = "";
    if (this.currentElement>=this.elements.length-1)
    {
      ret = {title:this.nextButtonValidateLabel, nextArrow:false};
    } else {
      ret = {title:this.nextButtonLabel, nextArrow:true};
    }

    let required = PcConfig.screen.infos.questions[this.currentElement].required;
    let kind = PcConfig.screen.infos.questions[this.currentElement].kind;
    PcConfig.dbg(CRASHDBG, "for sub form", this.currentElement, "required is: ", required);
    let qmem = PcConfig.getMemory("question"+this.currentElement);
    PcConfig.dbg(CRASHDBG, "for question", this.currentElement, "of kind", kind,"memory is", qmem);
    let qmem_exists = qmem != "" ;/*from getMemory defaulting undef to ""*/
    let cond =( !required || qmem_exists);

    PcConfig.dbg(CRASHDBG, "so: required", required, "qmem exists:", qmem_exists, "-> so allowNextButton cond:", cond);
    this.props.allowNextButton(cond); 
    /* IF required is false, call allowNextButton(true)
     ELSE IF required is true, call allowNextButton(false) 
     THEN further calls to allowNextButton(true) will be done by OnAnswerQuestion()
     this allows us to be sure we cannot click next until OnAnswerQuestion has been called
     -> solves bug app_client#29

     bug app_client#29 part 2: questions with single or multiple answers all in a row on the same sceen (scrolling down) 
     Enrich the condition for allowing Next button to work:
     Also, IF there already is a setMemory for this question (we went back with previous button, and forward with next button),
     consider Next button to be allowed as we DO already have a question memory, its contents will be saved in the database
     
     -> To sum up now:
      - when there is NO question memory, we NEED the prefilled form data to be ready/validated via onAnsweredQuestion() so the question memory is actually stored -> we allow the Next button to work
      - where there ALREADY IS a question memory, we directly enable the Next button.  
     */
    PcConfig.dbg(CRASHDBG, "exiting wit ret", JSON.stringify(ret));
    return ret;
  }

  onKeyPressed(key)
  {
    PcConfig.dbg(CRASHDBG, "entering", key);
    if (!this.initialized) return;
    if (!this.elements[this.currentElement].current || !this.elements[this.currentElement].current.onKeyPressed) return;
    this.elements[this.currentElement].current.onKeyPressed(key);
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  onAnsweredEmail(value)
  {
    PcConfig.dbg(CRASHDBG, "entering, value", value);
    console.log("answered email", value);

    if (value=="") return;
    PcConfig.setMemory('email', value);

    var id = PcConfig.getMemory("currentId");

    if (id)
    {
      this.elements[1].current.setValue(id[3]);
      this.elements[2].current.setValue(id[1]);
      this.elements[3].current.setValue(id[2]);
    }
    else {
      this.elements[1].current.setValue("");
      this.elements[2].current.setValue("");
      this.elements[3].current.setValue("");
    }
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  onAnsweredOptin(index, value)
  {
    PcConfig.dbg(CRASHDBG, "entering");
    var val;

    if (value=="Yes" || value==1)
    {
      val = 1;
    } else if (value=="No"  || value==0)
    {
      val = 0;
    }
    else {
      val = -1;
    }

    PcConfig.setMemory('question'+index, value);
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  onAnsweredQuestion(from, index, value)
  /*
  onAnsweredQuestion() actually calls setMemory on questions,
  this is where answers (prefilled or not) are actually stored. 
  */
  {
    PcConfig.dbg(CRASHDBG, "entering: from", from, "index", index, "value", value);
    if (value=="") {
      PcConfig.dbg(CRASHDBG, "no value, exiting early");
      return;
    }
    PcConfig.setMemory('question'+index, value);

    if (PcConfig.screen.infos.questions[index].kind=="prints")
    {
      PcConfig.setMemory("prints", Number(value));
    }

    if (PcConfig.screen.infos.questions[index].kind=="listing")
    {
        let idData = PcConfig.getMemory("currentId");
        console.log("idData", idData);

        for (let i=0; i<PcConfig.screen.infos.questions.length; i++)
        {
          let prefill = PcConfig.screen.infos.questions[i].prefill;        
          PcConfig.dbg(false, "question", i, "prefill", prefill, "element current", this.elements[i].curent);
          if (prefill!="" && prefill>0)
          {
            let prefill_data = "";
            if (idData != "")     {
              prefill_data = idData[prefill - 1];
            }            
            PcConfig.dbg(false, "->prefill_data", prefill_data);
            this.elements[i].current.setValue(prefill_data);
          }
        }
    }
    this.props.allowNextButton(true); // when onAnswredQuestion has been called thoroughly, then we can enable the PcScreenInfos Next button
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  onClickChoiceDoc(textFile)
  {
    PcConfig.dbg(CRASHDBG, "entering");
    if (this.props.onClickFormDoc){
      this.props.onClickFormDoc(textFile);
    }
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  validate()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    return this.elements[this.currentElement].current.validate();
  }

  render()
  {
    if (!this.props.active) return null;

    var index=0;

    const formQuestions = PcConfig.screen.infos.questions.map( (item)=> {
      let index=item.index;
      let elementClass = null;
      let showKeyboard;
      let keyboardType;
      let keyboardUppercase = false;

      switch (item.kind)
      {
        case "email" : elementClass = PcFormEmail; showKeyboard=true; keyboardType="email"; break;
        case "listing" : elementClass = PcFormEmail; showKeyboard=true; keyboardType="text"; break;
        case "uniqChoice" : elementClass = PcFormChoice; showKeyboard=false; keyboardType=""; break;
        case "multipleChoice" : elementClass = PcFormChoice; showKeyboard=false; keyboardType=""; break;
        case "number" : elementClass = PcFormNumber; showKeyboard=true; keyboardType="number"; break;
        case "text" : elementClass = PcFormText; showKeyboard=true; keyboardType="text"; keyboardUppercase = item.uppercase; break;
        case "prints" : elementClass = PcFormChoice; showKeyboard=false; keyboardType=""; break;
        default: elementClass = PcFormText; showKeyboard=true; keyboardType="text"; break;
      }

      if (item.kind=="prints" && PcConfig.screen.format.formats[PcConfig.getMemory("currentFormatIndex")].printing==false)
      {
        //do nothing
      }
      else
      {
        PcConfig.dbg(CRASHDBG, "about to render", item.kind, "with required", PcConfig.screen.infos.questions[item.index].required);
        return e(elementClass,
          {
            key:index,
            ref:this.questions[item.index],
            onClick:(e)=>this.onClickFormElement(index),
            okClick:()=>this.onClickOkButton(),
            onClickChoiceDoc:()=>this.onClickChoiceDoc(item.doc),
            kind:item.kind,
            answered:(from, value)=>this.onAnsweredQuestion(from, item.index, value),
            emailInputSwitchMode:(kind)=>this.emailInputSwitchMode(kind, index),
            emailInputSkip:()=>this.emailInputSkip(),
            errorMessageEmail:PcConfig.screen.infos.questions[item.index].error,//"Erreur email en dur",
            errorMessageId:PcConfig.screen.infos.questions[item.index].error,
            required:PcConfig.screen.infos.questions[item.index].required,
            listingFile:PcConfig.screen.infos.questions[item.index].file,
            listingText:PcConfig.screen.infos.textListing,
            docFile:PcConfig.screen.infos.questions[item.index].doc,
            showKeyboard:showKeyboard,
            keyboardType:keyboardType,
            keyboardUppercase:keyboardUppercase,
            active:this.props.active,
            label:item.label,
            mention:item.mention,
            type : item.kind,
            choices:item.choices,
            multipleChoices : item.kind=="multipleChoice" ? true : false,
            min:item.min,
            max:item.max,
            errorMessage:item.error,
            width:"100%",
            position:"relative",
            fontSize:PcConfig.scenario.fontSize,
            color: PcConfig.scenario.textColor,
            centered:this.props.centered,
            halign:"left",
            showDelay:"0,1s"
          }
        );
      }
    });

    return e('div',
      {
        style:
          {
            position:"absolute",
            width:"100%",
            top:0,
            left:0,
            height:"100%",
          }
      },
        e('div',
        {
          ref:this.formContainer,
          style:
            {
              position:"absolute",
              width:this.props.width,
              top:this.props.top,
              left:this.props.left,
              height:this.props.height,
              overflow:"hidden",
              //backgroundColor:"#ff0000"
            }
        },
          e('div',
            {
              ref:this.formElements,
              style:
              {
                position:"absolute",
                width:this.props.width,
                height:this.props.height,
                transition:"all 0.25s ease-out",
              }
            },
            formQuestions
          )
        ),
      e(PcKeyboard,
        {
          ref:this.keyboard,
          kind:this.state.keyboardKind,
          uppercase:this.state.keyboardUppercase,
          onKeyPressed:(key)=>this.onKeyPressed(key),
          x:this.props.left,
          y:this.props.height*PcMode.screen.infos.formKeyboardY,
          width:this.props.width,
          height:this.props.height*PcMode.screen.infos.formKeyboardH,
          fontSize:PcConfig.scenario.fontSizeBig,
          color: PcConfig.scenario.keyboardTextColor,
          backgroundColor: PcConfig.scenario.keyboardBackgroundColor,
          showDelay:"0,1s"
        }
      )
    );
  }

}
