class PcScreenCapture extends PcScreen
{
  constructor(props)
  {
    super(props);
    this.state = {flashVal:this.getNumShoots(), displayCounter:true}
    this.counter = React.createRef();
    this.camera = React.createRef();
    this.flash = React.createRef();
    this.steps = React.createRef();
    this.animationArrows = React.createRef();
    this.countWord = React.createRef();
    this.countWordLabel = React.createRef();
    this.preInfoLabel = React.createRef();
    this.infoLabel = React.createRef();

    this.animationSimple = "flashFadeOut 750ms ease-out 0s 1 forwards";
    this.animationLoop = "flashFlashing 500ms ease-out 0s 3 forwards";

    this.currentStep = 3;
    this.cameraHeight = 0;
  }

  getNumShoots()
  {
    var currentFormat = PcConfig.getMemory("currentFormat");
    var currentPoses = PcTemplates.getTemplate(currentFormat.paper, currentFormat.poses, currentFormat.layout).poses;

    if (currentFormat.animation=="none" || currentFormat.animation=="boomerang")
    {
      return currentPoses.length;
    }
    else
    {
      return 4;
    }
  }

  getAnimationMode()
  {
    var currentFormat = PcConfig.getMemory("currentFormat");
    return currentFormat.animation;
  }

  getNumCount()
  {
    if (this.getAnimationMode()=="boomerang")
    {
      if (this.state.flashVal == this.getNumShoots())
      {
        return 5;
      }
      else {
        return 2;
      }

    }
    else {
      return 5;
    }
  }

  updateInfoLabel()
  {
    let text ="";

    if (this.state.flashVal>1)
    {
      this.getAnimationMode()=="boomerang" ? text = PcConfig.screen.capture.textBoomerang[this.getNumShoots()+1-this.state.flashVal] : text = PcConfig.screen.capture.text[this.getNumShoots()+1-this.state.flashVal];
    }
    else if (this.state.flashVal==1)
    {
      if (this.getNumShoots()==1)
      {
        this.getAnimationMode()=="boomerang" ? text = PcConfig.screen.capture.textBoomerang[0] : text = PcConfig.screen.capture.text[0];
      }
      else {
        if (this.getAnimationMode()=="boomerang")
        {
          PcConfig.screen.capture.textBoomerang[5]!="" ? text = PcConfig.screen.capture.textBoomerang[5] : text = PcConfig.screen.capture.textBoomerang[5-this.state.flashVal];
        }
        else
        {
          PcConfig.screen.capture.text[5]!="" ? text = PcConfig.screen.capture.text[5] : text = PcConfig.screen.capture.text[5-this.state.flashVal];
        }

      }
    }

    this.preInfoLabel.current.updateLabel(text, true);
  }

  async onCount(n)
  {
    //console.log("oncount " + n)

    //first make sound
    if (this.getAnimationMode()!="boomerang" || this.state.flashVal == this.getNumShoots())
    {
      switch (n)
      {
        case 3 : PcConfig.sounds.counter3.play(); break;
        case 2 : PcConfig.sounds.counter2.play(); break;
        case 1 : PcConfig.sounds.counter1.play(); break;
      }
    }

    //then decide what to do with the counter
    if (n<=3)
    {
        if (this.getAnimationMode()!="boomerang")
        {
          this.infoLabel.current.updateLabel(PcConfig.screen.capture.textCount, n==3 ? true : false);
          this.camera.current.setOpacity(1);
          this.preInfoLabel.current.updateLabel("");
        }

        //this.getAnimationMode()=="boomerang" ? this.infoLabel.current.updateLabel(PcConfig.screen.capture.textCountBoomerang, n==3 ? true : false) : this.infoLabel.current.updateLabel(PcConfig.screen.capture.textCount, n==3 ? true : false);
    }

    if (n==2)
    {
        if (this.getAnimationMode() != "boomerang")
        {

          await Promise.all([PcConfig.promiseSleep(750)]);
          await PcCameraControl.shoot();
        }
        else
        {
          PcCameraControl.startVideoRecording();
        }
    }

    if (n==1)
    {
      let timeOut = 1100;

      if (this.getAnimationMode()=="boomerang")
      {
        this.counter.current.changeStartVal(3);
        setTimeout(()=>{this.infoLabel.current.updateLabel("")},1000);
        timeOut = 2500;
      }

      setTimeout(()=>{
          if (this.camera.current) this.camera.current.setOpacity(0.25);
          this.updateInfoLabel();
          this.infoLabel.current.updateLabel("");
          if (this.state.flashVal==0 && this.getAnimationMode()!="boomerang") this.camera.current.setOpacity(1);
      }, timeOut);
    }


   

  }

  onEndCount()
  {
    if (this.getAnimationMode()=="boomerang")
    {
      this.preInfoLabel.current.updateLabel("");
      this.preInfoLabel.current.changeHeight(this.cameraHeight);
      this.camera.current.setOpacity(1);
    }

    if (!this.playing)
    {
      this.state.flashVal = this.getNumShoots();
      this.initFlash();
    }

    if (this.state.flashVal>0)
    {
      this.counter.current.hide();
      this.counter.current.initCount();
    }

    this.counter.current.showLongCounter(false);
  }

  initFlash()
  {
    this.playing = true;
    this.doFlash();
  }

  resetFlash()
  {
    this.playing = false;
    this.state.flashVal=this.getNumShoots();
    this.flash.current.style.display="none";
    this.counter.current.hide();
  }

  doFlash()
  {
    if (this.state.flashVal>0)
    {
      this.flash.current.style.display="none";
      this.state.flashVal = this.state.flashVal-1;

      setTimeout(()=>{
          this.flash.current.style.display="table-cell";

          if (this.getAnimationMode()!="boomerang") this.counter.current.show();

          if (this.getAnimationMode()=="boomerang")
          {
            PcConfig.sounds.flashLoop.play();
            PcCameraControl.flashStamp.push((Date.now()/1000)-PcCameraControl.startStamp);

            if (PcCameraControl.useDSLR()==false && PcCameraControl.webcamActive==true)
            {
              for (let j=0; j<8; j++)
              {
                let t = (j*1.5/7)*1000;
                setTimeout(()=>{PcCameraControl.doBoommerangShoot()}, t);
              }
              setTimeout(()=>{PcCaptureSession.nextShot()}, (8*1.5/7)*1000);
            }
          }
          else {
            PcConfig.sounds.flash.play();
          }

        }, 100);

      if (this.state.flashVal==0)
      {
        setTimeout(()=>this.doFlash(), (this.getNumCount()+1)*1000/4);
      }
      else
      {
        setTimeout(()=>this.doFlash(), (this.getNumCount()+1)*1000);
      }
    }
    else
    {

      if (this.getAnimationMode()=="boomerang")
      {
        setTimeout(()=>{
          this.camera.current.setOpacity(0.25);
          PcCameraControl.stopVideoRecording();
        }, 1500);

        setTimeout(()=>{
          this.resetFlash();
          this.props.goNextScreen();
        }, 2000);
      }
      else {
        this.resetFlash();
        this.props.goNextScreen();
      }

    }
  }

  componentDidUpdate()
  {
    if (this.props.active)
    {
      if (this.counter.current)
      {
        this.counter.current.showLongCounter(false);
        this.counter.current.initCount();
        this.counter.current.show();
        this.state.flashVal=this.getNumShoots();

        this.updateInfoLabel();
        this.camera.current.setOpacity(0.25);
      }
    }
  }

  render()
  {
    if (!this.props.active) return null;

    let cameraWidth, cameraHeight, cameraTop, cameraLeft, titleY;
    let currentFormat = PcConfig.getMemory("currentFormat");
    let currentPose = PcTemplates.getTemplate(currentFormat.paper, currentFormat.poses, currentFormat.layout).poses[0];

    let poseRatio = currentPose.width/currentPose.height;

    if (PcMode.mode == "photobooth" || PcMode.mode == "cyclomaton")
    {
      if (poseRatio>1)
      {
        cameraWidth = 1000 * PcConfig.renderSize;
        cameraHeight = 1000 / poseRatio * PcConfig.renderSize;
      } else {
        cameraHeight = 720 * PcConfig.renderSize;
        cameraWidth = 720 * poseRatio * PcConfig.renderSize;
      }

      cameraTop = (this.props.height-cameraHeight)/2;
      cameraLeft = (this.props.width-cameraWidth)/2;
      titleY = this.props.height*(0.03);
    }
    else if (PcMode.mode == "photokiosk")
    {
      if (poseRatio>1)
      {
        cameraWidth = 1080 * PcConfig.renderSize;
        cameraHeight = 1080 / poseRatio * PcConfig.renderSize;
      } else {
        cameraHeight = 720 * PcConfig.renderSize;
        cameraWidth = 720 * poseRatio * PcConfig.renderSize;
      }
      cameraTop = 0;
      cameraLeft = (this.props.width-cameraWidth)/2;
      titleY = cameraTop + cameraHeight;
    }

    this.cameraHeight = cameraHeight;

    let shadow = 5*PcConfig.renderSize;

    return e('div',
      {
        className:this.state.className,
        index:this.props.index,
        style:
        {
          display: (this.props.active ? 'block' : 'none'),
          fontFamily:PcConfig.scenario.fontFamily,
          animation:"",//this.props.noAnimation?"":this.state.animationStyle
        },
      },
      e(PcCamera,
        {
          ref:this.camera,
          width:cameraWidth,
          height:cameraHeight,
          x:cameraLeft,
          y:cameraTop,
          animation:"elementMoveDownAndFadeIn 0s ease-out 0s 1 normal forwards",
          animationDelay:0,
          active:this.props.active,
          foreground:currentFormat.foreground,
        }
      ),
      e(PcLabel,
        {
          ref:this.preInfoLabel,
          label:"",
          width:cameraWidth*0.9,
          height:this.getAnimationMode()=="boomerang" ? cameraHeight/2 : cameraHeight,
          x:cameraLeft+cameraWidth*0.05,
          y:cameraTop,
          fontSize:PcConfig.scenario.fontSizeVeryBig,
          shadow: 4*PcConfig.renderSize + "px " + 4*PcConfig.renderSize + "px " + 4*PcConfig.renderSize + "px rgba(0, 0, 0, 0.66)",
          color:"#ffffff",
          showDelay:"0s"
        }
      ),
      e(PcLabel,
        {
          ref:this.infoLabel,
          label:"",
          width:cameraWidth*0.9,
          height:(PcMode.mode=="photobooth" || PcMode.mode=="cyclomaton") ? cameraHeight/2 : cameraHeight,
          x:cameraLeft+cameraWidth*0.05,
          y:cameraTop,
          fontSize:PcConfig.scenario.fontSizeVeryBig,
          shadow: 4*PcConfig.renderSize + "px " + 4*PcConfig.renderSize + "px " + 4*PcConfig.renderSize + "px rgba(0, 0, 0, 0.66)",
          color:"#ffffff",
          showDelay:"0s"
        }
      ),
      e(PcCounter,
        {
          ref:this.counter,
          active:this.props.active,
          display:this.state.displayCounter,
          startVal:this.getNumCount()+1,
          delay:1000,
          onCount:(n)=>this.onCount(n),
          onEndCount:()=>this.onEndCount(),
          width:(PcMode.mode=="photobooth" || PcMode.mode=="cyclomaton") ? cameraWidth : 500*PcConfig.renderSize,
          height:(PcMode.mode=="photobooth" || PcMode.mode=="cyclomaton") ? cameraHeight/2.5 : 500*PcConfig.renderSize,
          x:(PcMode.mode=="photobooth" || PcMode.mode=="cyclomaton") ? cameraLeft : (this.props.width - 500*PcConfig.renderSize)/2,
          y:(PcMode.mode=="photobooth" || PcMode.mode=="cyclomaton") ? cameraTop+cameraHeight/2 : cameraTop+cameraHeight + (this.props.height - (cameraTop+cameraHeight) - 500*PcConfig.renderSize)/2,
          shadow: 4*PcConfig.renderSize + "px " + 4*PcConfig.renderSize + "px " + 4*PcConfig.renderSize + "px rgba(0, 0, 0, 0.66)",
          color:PcConfig.scenario.counterFontColor,
          showDelay:"1s"
        }
      ),
      e('div',
        {
          ref:this.flash,
          className:"flash",
          style:
          {
            position:"absolute",
            display:"none",
            backgroundColor:"#ffffff",
            width:"100%",
            height:"100%",
            animation: this.getAnimationMode()=="boomerang" ? this.animationLoop : this.animationSimple,
          }
        }
      )
    );
  }
}
