<?php
include_once 'scripts/config.php' ;

$config = array_key_exists('config', $_GET) ? $_GET['config'] : 'xml/config.xml' ;
$scale     = array_key_exists('scale', $_GET) ? (float) $_GET['scale'] : 1 ;
$oConfigXml = loadConfig($config) ;

$base_locale = dirname(__FILE__) . '/' ;
$checksum_config = md5_file($base_locale . 'xml/config.xml') ;
?>

<html>
<head>
    <title>Photocabine</title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta name="language" content="fr" />
    <link href="gfx/favicon.ico" rel="icon" type="image/x-icon" />
    <script src="js/jquery.min.js" type="text/javascript"></script>
    <?php if($oConfigXml->screen->background_video) { ?>
    <script src="js/VV1bjsShEeKGLRIxOQulpA.js"></script>
    <?php } ?>

    <style>
    #diaporama
    {
        position:absolute;
    }

    #diaporama > img
    {
        position:absolute;
        top:0;
        left:0;
        height:100%;
        z-index:1;
        <?= $oConfigXml->photoExt->slideshow->slideshowShadow=="1" ? "box-shadow: 1px 1px 12px #555555;" : "" ?>
    }

    .back
    {
        width:<?php echo 1080 * $scale ;?>px;
        height:<?php echo 1920 * $scale ;?>px;
    }

    <?php
    $file = $oConfigXml->photoExt->general->background;
    $ext = pathinfo($file, PATHINFO_EXTENSION);

    if (strtolower($ext)=="mp4" || strtolower($ext)=="mpg")
    {
      $fileType = "video";
    }
    else {
      $fileType = "image";
    }

    $diap_default_rotation = (int) $oConfigXml->photoExt->slideshow->slideshowDefaultRotation ;
    $diap_rotation = (int) $oConfigXml->photoExt->slideshow->slideshowRotation ;
    $video_rotation = (int) $oConfigXml->photoExt->general->backgroundRotation ;

    $video_rotation = 0;

    if($video_rotation) {

      $vw = (abs($video_rotation)==90) ? 1920*$scale : 1080*$scale;
      $vh = (abs($video_rotation)==90) ? 1080*$scale : 1920*$scale;

    ?>

    #video
    {
        /* Rotation du div */
        transform-origin: center;
        transform: rotate(<?=$video_rotation?>deg);
        width:100%;
        height:100%;
        object-fit: fill;
    }

    <?php } ?>

    </style>
</head>
<body style="margin:0;padding:0;overflow:hidden;">
    <div id="content">
        <?php
        if($file != '' && $fileType=="image")
        {
            echo '<img class="back" " src="' . $oConfigXml->photoExt->general->background . '" />' ;
        }
        else if ($file != '' && $fileType=="video")
        {
          echo "<video class='video' id='video' width='100%' height='100%' autoplay='true' loop='true' muted='true' style='objectFit:\'fill\'><source src='".$oConfigXml->photoExt->general->background."' type='video/mp4'></video>";
        }

        if($oConfigXml->photoExt->slideshow->slideshow == '1')
        {
            $x = (int) $oConfigXml->photoExt->slideshow->slideshowX * $scale ;
            $y = (int) $oConfigXml->photoExt->slideshow->slideshowY * $scale ;
            $h = (int) $oConfigXml->photoExt->slideshow->slideshowH * $scale ;

            echo '<div id="diaporama" style="top:' . $y . 'px;left:' . $x . 'px;height:' . $h . 'px;">' ;
            echo '</div>' ;
        }

        /*
        if($file != '' && $fileType=="video")
        {
        ?>
        <video id="video" preload="auto" autoplay="true" loop="loop" style="width:<?php echo (abs($video_rotation) == 90 ? 1920 : 1080) * $scale ;?>px;height:<?php echo (abs($video_rotation) == 90 ? 1080 : 1920) * $scale ;?>px;">
            <source src="<?php echo $file ; ?>" type="video/mp4" />
        </video>
        <?php
        }
        */
        ?>
    </div>
    <?php if($oConfigXml->photoExt->slideshow->slideshow == '1') { ?>
    <script type="text/javascript">
    <!--
    var bRotation = <?php echo $diap_rotation ; ?> ;
    var defaultRotation = <?php echo $diap_default_rotation ; ?> ;

		function launchDiap(reset=true)
        {
            reset ? resetString="&reset=1" : resetString="";
            $.post('scripts/random_photo.php?config=<?php echo $oConfigXml->id ; ?>'+resetString, function(data)
            {
                if(data)
                {
                    console.log("launch data ok");
                    var elt1 = $('<img src="' + data + '" class="current"/>') ;
                    $('#diaporama').append(elt1) ;

                    if (bRotation)
                    {
                      rotateImg(elt1, parseInt(Math.random() * 11) - 5) ;
                    }
                    else {
                      rotateImg(elt1, defaultRotation) ;
                    }

                    setTimeout('loadNextPhoto()', 4000) ;
                }
                else {
                  console.log("launch data NOT ok");
                  setTimeout('launchDiap(false)', 4000) ;
                }

            })
            .fail( function(error)
                {
                  console.log("launch FAIL");
                    setTimeout('launchDiap(false)', 4000) ;
                }
              );
        }

        function rotateImg(elt1, degree)
        {
            elt1.css({
                        '-webkit-transform': 'rotate(' + degree + 'deg)',
                        '-moz-transform': 'rotate(' + degree + 'deg)',
                        '-ms-transform': 'rotate(' + degree + 'deg)',
                        '-o-transform': 'rotate(' + degree + 'deg)',
                        'transform': 'rotate(' + degree + 'deg)',
                        'zoom': 1}) ;
        }

        function loadNextPhoto()
        {
            $.post('scripts/random_photo.php?config=<?php echo $oConfigXml->id ; ?>', function(data)
            {
                if(data)
                {
                    $('#diaporama .current').css('z-index', 10) ;

                    var elt1 = $('<img src="' + data + '" class="next"/>') ;

                    if (bRotation)
                    {
                      rotateImg(elt1, parseInt(Math.random() * 11) - 5) ;
                    }
                    else {
                      rotateImg(elt1, defaultRotation) ;
                    }

                    $('#diaporama').append(elt1) ;

                    $('#diaporama .current').animate({opacity:0}, 500, onPhotoFaded) ;
                    $('#diaporama .currentfg').animate({opacity:0}, 500) ;
                }
                else {
                  setTimeout('loadNextPhoto()', 4000) ;
                }
            })
            .fail( function(error)
                {
                    setTimeout('loadNextPhoto()', 4000) ;
                }
              );
        }

        function onPhotoFaded()
        {
            $('#diaporama .current').remove() ;
            $('#diaporama .currentfg').remove() ;

            $('#diaporama .next').addClass('current') ;
            $('#diaporama .nextfg').addClass('currentfg') ;

            setTimeout('loadNextPhoto()', 4000) ;
        }

        launchDiap() ;
    -->
    </script>
    <?php } ?>
    <script type="text/javascript">
        function checkConfig()
        {
            $.post('scripts/check_config.php?checksum=<?php echo $checksum_config ; ?>', function(data)
            {
                if(data == 'ok')
                {
                    window.location.reload() ;
                }else{
                    setTimeout('checkConfig()', 15 * 1000) ;
                }
            }) ;
        }
        checkConfig() ;
    </script>
</body>
</html>
